program hobcat;



uses
  Forms,
  Windows,
  SysUtils,
  Dialogs,
  UfrmMain in 'UfrmMain.pas' {frmMain},
  UfrmCal in 'UfrmCal.pas' {frmCal},
  UIniData in 'UIniData.pas',
  UfrmComSel in 'UfrmComSel.pas' {frmComSel},
  About in 'About.pas' {AboutBox},
  UGlobals in 'UGlobals.pas',
  UfrmRtf in 'UfrmRtf.pas' {frmRtf},
  UOwdxPrintConfig in 'UOwdxPrintConfig.pas',
  UfrmPreSetup in 'UfrmPreSetup.pas' {frmPreSetup},
  UfrmSummaryExport in 'UfrmSummaryExport.pas' {frmSummaryExport},
  URichText in 'URichText.pas',
  UfrmDebug in 'UfrmDebug.pas' {frmDebug},
  CfgUnit in 'CfgUnit.pas' {SetupForm},
  D2XXUnit in 'D2XXUnit.pas',
  UUsb in 'UUsb.pas',
  UfrmDSP in 'UfrmDSP.pas' {frmDSP},
  UfrmDDS in 'UfrmDDS.pas' {frmDDS},
  UfrmCalswr in 'UfrmCalswr.pas' {frmCalswr},
  UfrmUpdate in 'UfrmUpdate.pas' {frmUpdate},
  UfrmLoadCodeParams in 'UfrmLoadCodeParams.pas' {frmLoadCodeParams},
  UfrmLoadParams in 'UfrmLoadParams.pas' {frmLoadParams},
  UfrmLoadCode in 'UfrmLoadCode.pas' {frmLoadCode},
  UfrmDownloadParams in 'UfrmDownloadParams.pas' {frmDownloadParams},
  UfrmLoading in 'UfrmLoading.pas' {frmLoading},
  UfrmSelectStarDir in 'UfrmSelectStarDir.pas' {frmSelectStarDir},
  UfrmDirectDSP in 'UfrmDirectDSP.pas' {frmDirectDSP},
  UParams in 'UParams.pas',
  UfrmDSPtelem in 'UfrmDSPtelem.pas' {frmDSPtelem},
  UfrmDDSclock in 'UfrmDDSclock.pas' {frmDDSclock},
  UfrmEEMEM in 'UfrmEEMEM.pas' {frmEEMEM},
  UfrmHardware in 'UfrmHardware.pas' {frmHardware},
  UfrmCalCurve in 'UfrmCalCurve.pas' {frmCalCurve},
  UfrmParamFile in 'UfrmParamFile.pas' {frmParamFile},
  UfrmPortDiagnostic in 'UfrmPortDiagnostic.pas' {frmPortDiagnostic},
  UfrmTFTflash in 'UfrmTFTflash.pas' {frmTFTflash},
  UfrmI2C in 'UfrmI2C.pas' {frmI2C},
  UfrmWeb in 'UfrmWeb.pas' {frmWeb},
  UfrmDatabase in 'UfrmDatabase.pas' {frmDatabase},
  UfrmDBpassword in 'UfrmDBpassword.pas' {frmDBpassword},
  UfrmDBRtf in 'UfrmDBRtf.pas' {frmDBrtf},
  UDBRichText in 'UDBRichText.pas',
  UfrmRTC in 'UfrmRTC.pas' {frmRTC},
  UfrmTftA_I2Caddress in 'UfrmTftA_I2Caddress.pas' {frmTftA_I2Caddress},
  UfrmUsrow in 'UfrmUsrow.pas' {frmUsrow},
  UfrmSelectTrxAVR in 'UfrmSelectTrxAVR.pas' {frmSelectTrxAVR};

{$R *.res}

const
  AllowedInstances = 1;

var
  MyAppName   : Array[0..255] of Char;
  MyClassName : Array[0..255] of Char;
  NumFound    : Integer;
  LastFound   : HWnd;
  MyPopup     : HWnd;
  s: string;

function LookAtAllWindows(Handle: HWND; Temp: LongInt): BOOL; stdcall;
var
  WindowName : Array[0..255] of Char;
  ClassName  : Array[0..255] of Char;
begin
  // Go get the windows class name
  if GetClassName(Handle,ClassName,SizeOf(ClassName)) > 0 then
    // Is the window class the same?
    if StrComp(ClassName,'TfrmMain') = 0 then
      // Get its window caption
      if GetWindowText(Handle,WindowName,SizeOf(WindowName)) > 0 then
        // Does this have the same window title?
        s := WindowName;
        if Copy(s,2,6) = 'HOBCAT' then
          begin
            inc(NumFound);
            // Are the handles different?
            if Handle <> Application.Handle then
              // Save it so we can bring it to the top later.
              LastFound := Handle;
          end;
end;

begin
  NumFound := 0; LastFound := 0;
  // First, determine what this application's name is
  GetWindowText(Application.Handle,MyAppName,SizeOf(MyAppName));
  // Now determine the class name for this application
  GetClassName(Application.Handle,MyClassName,SizeOf(MyClassName));
  // Now count how many others out there are Delphi apps with this title
  EnumWindows(@LookAtAllWindows,0);
  if NumFound <= AllowedInstances then
  begin
    // None running - allow this instance to continue
    Application.Initialize;
    Application.Title := 'hobcat';
    Application.ShowHint := true;
    Application.HintHidePause := 4000;
    g_HobcatVersion := '1.2.0.3';
    Application.CreateForm(TfrmMain, frmMain);
    Application.CreateForm(TAboutBox, AboutBox);
//  Application.CreateForm(TfrmPreSetup, frmPreSetup);
//  Application.CreateForm(TfrmSummaryExport, frmSummaryExport);
//  Application.CreateForm(TfrmRTC, frmRTC);
//  Application.CreateForm(TfrmTftA_I2Caddress, frmTftA_I2Caddress);
//  Application.CreateForm(TfrmUsrow, frmUsrow);
//  Application.CreateForm(TfrmSelectTrxAVR, frmSelectTrxAVR);
  Application.Run;
  end
  else MessageDlg('Another instance of HOBCAT is already running',mtWarning,[mbAbort],0);
end.
